CV_RegisterVar({name = "speccy_hud", defaultvalue = "On", flags = nil, PossibleValue = CV_OnOff, func = nil})

local lowringtimer = 0

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then 
		hud.enable("score")
		hud.enable("time")
		hud.enable("rings")
		hud.enable("lives")
		return 
	end
	
	if not CV_FindVar("speccy_hud").value then
		hud.enable("score")
		hud.enable("time")
		hud.enable("rings")
		hud.enable("lives")
		return 
	end
	
	if netgame or (gametype ~= GT_COOP) then return end
	
	hud.disable("score")
	hud.disable("time")
	hud.disable("rings")
	hud.disable("lives")
end)

hud.add(function(v, p)
	if p.powers[pw_carry] == CR_NIGHTSMODE then return end
	if (skins["samus"] ~= nil) then
		if p.speccysamus ~= nil then
			local beamhud
			
			if p.speccysamus.charge > 0 and p.speccysamus.charge <= p.speccysamus.allbeams[p.speccysamus.beam][5]/4*2 then
				beamhud = v.getSprite2Patch("speccy", SPR2_TIRE, 1, 0, FixedAngle(-(p.cmd.sidemove-10)/6*FRACUNIT))
			elseif p.speccysamus.charge > 0 and p.speccysamus.charge <= p.speccysamus.allbeams[p.speccysamus.beam][5]/4*3 then
				beamhud = v.getSprite2Patch("speccy", SPR2_TIRE, 2, 0, FixedAngle(-(p.cmd.sidemove-10)/6*FRACUNIT))
			elseif p.speccysamus.charge > 0 and p.speccysamus.charge < p.speccysamus.allbeams[p.speccysamus.beam][5] then
				beamhud = v.getSprite2Patch("speccy", SPR2_TIRE, 3, 0, FixedAngle(-(p.cmd.sidemove-10)/6*FRACUNIT))
			elseif p.speccysamus.charge >= p.speccysamus.allbeams[p.speccysamus.beam][5] then
				beamhud = v.getSprite2Patch("speccy", SPR2_TIRE, 4, 0, FixedAngle(-(p.cmd.sidemove-10)/6*FRACUNIT))
			else
				beamhud = v.getSprite2Patch("speccy", SPR2_TIRE, 0, 0, FixedAngle(-(p.cmd.sidemove-10)/6*FRACUNIT))
			end
		
			if not camera.chase then
				v.draw(172+(p.cmd.sidemove/20), 120-(p.cmd.sidemove/10), beamhud, V_SNAPTORIGHT|V_SNAPTOBOTTOM, v.getColormap("speccy", p.speccysamus.allbeams[p.speccysamus.beam][8]))
			end
			
			if p.speccysamus.beam == 1 then
				v.drawScaled(3*FRACUNIT, 181*FRACUNIT, FRACUNIT/2, v.cachePatch("WEAPPWBM"), V_SNAPTOLEFT|V_SNAPTOBOTTOM)
			else
				v.drawScaled(3*FRACUNIT, 181*FRACUNIT, FRACUNIT/2, v.cachePatch("WEAPPWBM"), V_50TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
			end
			if p.speccysamus.beams[2] > 0 and (p.speccysamus.beam ~= 2) then
				v.drawScaled(3*FRACUNIT, 168*FRACUNIT, FRACUNIT/2, v.cachePatch("WEAPSPBM"), V_50TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
			elseif p.speccysamus.beam == 2 then
				v.drawScaled(3*FRACUNIT, 168*FRACUNIT, FRACUNIT/2, v.cachePatch("WEAPSPBM"), V_SNAPTOLEFT|V_SNAPTOBOTTOM)
			end
			if p.speccysamus.beams[3] > 0 and (p.speccysamus.beam ~= 3) then
				v.drawScaled(3*FRACUNIT, 155*FRACUNIT, FRACUNIT/2, v.cachePatch("WEAPWVBM"), V_50TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
			elseif p.speccysamus.beam == 3 then
				v.drawScaled(3*FRACUNIT, 155*FRACUNIT, FRACUNIT/2, v.cachePatch("WEAPWVBM"), V_SNAPTOLEFT|V_SNAPTOBOTTOM)
			end
			if p.speccysamus.beams[4] > 0 and (p.speccysamus.beam ~= 4) then
				v.drawScaled(3*FRACUNIT, 142*FRACUNIT, FRACUNIT/2, v.cachePatch("WEAPICBM"), V_50TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
			elseif p.speccysamus.beam == 4 then
				v.drawScaled(3*FRACUNIT, 142*FRACUNIT, FRACUNIT/2, v.cachePatch("WEAPICBM"), V_SNAPTOLEFT|V_SNAPTOBOTTOM)
			end
			if p.speccysamus.beams[5] > 0 and (p.speccysamus.beam ~= 5) then
				v.drawScaled(3*FRACUNIT, 129*FRACUNIT, FRACUNIT/2, v.cachePatch("WEAPPLBM"), V_50TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
			elseif p.speccysamus.beam == 5 then
				v.drawScaled(3*FRACUNIT, 129*FRACUNIT, FRACUNIT/2, v.cachePatch("WEAPPLBM"), V_SNAPTOLEFT|V_SNAPTOBOTTOM)
			end		
			
			if p.speccysamus.maxmissiles and p.mo.missiletrns != nil
				if p.micatchupflash and (p.micatchupflash > 15)
					v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT, hudinfo[HUD_LIVES].y*FRACUNIT-20*FRACUNIT, FRACUNIT, v.cachePatch("0000MIB"), (p.mo.missiletrns)|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
					v.drawString(hudinfo[HUD_LIVES].x+27, hudinfo[HUD_LIVES].y-16, "+"+p.micatchupnum, V_60TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				else
					v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT, hudinfo[HUD_LIVES].y*FRACUNIT-20*FRACUNIT, FRACUNIT, v.cachePatch("0000MI"), (p.mo.missiletrns)|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
				end
				if p.micatchupflash and (p.micatchupflash < 5)
					v.drawString(hudinfo[HUD_LIVES].x+27, hudinfo[HUD_LIVES].y-16, "+"+p.micatchupnum, V_60TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				elseif p.micatchupflash and (p.micatchupflash < 17)
					v.drawString(hudinfo[HUD_LIVES].x+27, hudinfo[HUD_LIVES].y-16, "+"+p.micatchupnum, V_20TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				end
				if p.speccysamus.missiles >= p.speccysamus.maxmissiles
						v.drawString(hudinfo[HUD_LIVES].x+8, hudinfo[HUD_LIVES].y-16, "\x82"+p.speccysamus.missiles, V_20TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				elseif not p.speccysamus.missiles or ((p.samdoubleammo or p.fusionmode) and p.speccysamus.missiles == 1)
						v.drawString(hudinfo[HUD_LIVES].x+8, hudinfo[HUD_LIVES].y-16, "\x87"+p.speccysamus.missiles, V_20TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				else
						v.drawString(hudinfo[HUD_LIVES].x+8, hudinfo[HUD_LIVES].y-16, p.speccysamus.missiles, V_20TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				end
			end
			
			if p.speccysamus.maxsmissiles and p.mo.supermissiletrns != nil
				if p.smcatchupflash and (p.smcatchupflash > 15)
					v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT, hudinfo[HUD_LIVES].y*FRACUNIT-40*FRACUNIT, FRACUNIT, v.cachePatch("0000SMB"), (p.mo.supermissiletrns)|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
					v.drawString(hudinfo[HUD_LIVES].x+27, hudinfo[HUD_LIVES].y-36, "+"+p.smcatchupnum, V_60TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				else
					v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT, hudinfo[HUD_LIVES].y*FRACUNIT-40*FRACUNIT, FRACUNIT, v.cachePatch("0000SM"), (p.mo.supermissiletrns)|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
				end
				if p.smcatchupflash and (p.smcatchupflash < 5)
					v.drawString(hudinfo[HUD_LIVES].x+27, hudinfo[HUD_LIVES].y-36, "+"+p.smcatchupnum, V_60TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				elseif p.smcatchupflash and (p.smcatchupflash < 17)
					v.drawString(hudinfo[HUD_LIVES].x+27, hudinfo[HUD_LIVES].y-36, "+"+p.smcatchupnum, V_20TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				end
				if p.speccysamus.smissiles >= p.speccysamus.maxsmissiles
				v.drawString(hudinfo[HUD_LIVES].x+8, hudinfo[HUD_LIVES].y-36, "\x82"+p.speccysamus.smissiles, V_20TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				elseif not p.speccysamus.smissiles or (p.samdoubleammo or p.fusionmode) and p.speccysamus.smissiles == 1
				v.drawString(hudinfo[HUD_LIVES].x+8, hudinfo[HUD_LIVES].y-36, "\x87"+p.speccysamus.smissiles, V_30TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				else
				v.drawString(hudinfo[HUD_LIVES].x+8, hudinfo[HUD_LIVES].y-36, p.speccysamus.smissiles, V_20TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "center")
				end
			end
		end
	end
	if netgame or (gametype ~= GT_COOP) then return end

	if not (p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if not CV_FindVar("speccy_hud").value then return end
	if G_IsSpecialStage(gamemap) then return end
	
	local gring = v.getSpritePatch("RING", 5, 0)
	local ring = v.getSpritePatch("TRNG", 5, 0)
	local life = v.getSprite2Patch("speccy", "LIFE", 0, 0)
	local time = v.cachePatch("SPCHTIME")
	
	v.drawScaled(12*FRACUNIT, 15*FRACUNIT, FRACUNIT, life, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER, v.getColormap("speccy", p.mo.color))
	if p.lives ~= 127 then
		v.drawString(22, 12, "x ", V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
		if p.lives < 99 then
			v.drawPaddedNum(48, 9, p.lives, 2, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
		else
			v.drawPaddedNum(48, 9, p.lives, 2, V_SNAPTOLEFT|V_SNAPTOTOP|V_YELLOWMAP|V_PERPLAYER)
		end
	end
	
	if lowringtimer >= 16 then lowringtimer = 0 end
	
	lowringtimer = $ + 1
	
	if p.rings < 1 then
		if lowringtimer >= 8 then
			v.drawScaled(12*FRACUNIT, 19*FRACUNIT+18*FRACUNIT, FRACUNIT/2, ring, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER, v.getColormap(nil, SKINCOLOR_RED))
		else
			v.drawScaled(12*FRACUNIT, 19*FRACUNIT+18*FRACUNIT, FRACUNIT/2, gring, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
		end
	else
		v.drawScaled(12*FRACUNIT, 19*FRACUNIT+18*FRACUNIT, FRACUNIT/2, gring, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
	end
	v.drawString(22, 12+18, "x ", V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
	if p.rings < 9999 then
		if p.rings == 0 then
			v.drawPaddedNum(64, 9+18, p.rings, 4, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
		else
			v.drawPaddedNum(64, 9+18, p.rings, 4, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
		end
	else
		v.drawPaddedNum(64, 9+18, p.rings, 4, V_SNAPTOLEFT|V_SNAPTOTOP|V_YELLOWMAP|V_PERPLAYER)
	end
	
	v.drawScaled((320-64+14)*FRACUNIT, 2*FRACUNIT, FRACUNIT/2, time, V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
	v.drawPaddedNum(320-64+58, 5, leveltime/TICRATE, 3, V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
	
	v.drawString(320-(string.len(p.score)*8)-6, 20, p.score, V_SNAPTORIGHT|V_SNAPTOTOP)
end, "game")

-- Emblem non-sense, makes me wanna cry.
-- Moving this here btw--
freeslot("MT_SPECCYEMBLEM", "S_SPECCYEMBLEM", "SPR_SEMB")

local emblemlist = {}

addHook("PreThinkFrame", function(emblem)
	if leveltime > 3 then return end
	emblemlist = {}
	for emblem in mobjs.iterate() do
		if (emblem.type == MT_EMBLEM) then
			emblemlist[AngleFixed(emblem.angle)/FRACUNIT] = {
				frame = emblem.frame,
				color = emblem.color,
				id = AngleFixed(emblem.angle)/FRACUNIT,
				mobj = emblem
			}
		elseif (emblem.type == MT_SPECCYEMBLEM) then 
			emblemlist[emblem.id] = {
				frame = emblem.frame,
				color = emblem.color,
				id = emblem.id,
				mobj = emblem
			}
		end
	end
end)

addHook("TouchSpecial", function(emblem, pmo)
	emblemlist[AngleFixed(emblem.angle)/FRACUNIT] = {
		frame = emblem.frame|FF_TRANSMASK,
		color = emblem.color,
		id = AngleFixed(emblem.angle)/FRACUNIT,
		mobj = emblem
	}
end, MT_EMBLEM)

addHook("TouchSpecial", function(semb, pmo)
	emblemlist[semb.id] = {
		frame = semb.frame|FF_TRANSMASK,
		color = semb.color,
		id = semb.id,
		mobj = semb
	}
end, MT_SPECCYEMBLEM)

hud.add(function(v)
	if netgame or (gametype ~= GT_COOP) then return end
	local p = consoleplayer
	if not (p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if not CV_FindVar("speccy_hud").value then return end
			
	local startx = 160-(#emblemlist*14)
	
	if #emblemlist == 0 then return end
		
	for i=0,#emblemlist do
		local emblem = v.getSpritePatch("EMBM", emblemlist[i].frame & FF_FRAMEMASK)
		if modifiedgame then
			emblem = v.getSpritePatch("SEMB", emblemlist[i].frame & FF_FRAMEMASK)
		end
		
		v.drawScaled((startx+i*28)*FRACUNIT, hudinfo[HUD_SCORE].y*FRACUNIT+16*FRACUNIT, FRACUNIT/2, emblem, V_70TRANS|V_SNAPTOTOP|V_PERPLAYER, v.getColormap(nil, emblemlist[i].color)) 
			
		if (emblemlist[i].frame & FF_TRANSMASK) or (not emblemlist[i].mobj.valid) then
			v.drawScaled((startx+i*28)*FRACUNIT, hudinfo[HUD_SCORE].y*FRACUNIT+16*FRACUNIT, FRACUNIT/2, emblem, V_SNAPTOTOP|V_PERPLAYER, v.getColormap(nil, emblemlist[i].color)) 
		end
	end
end, "scores")